=== modified file 'src/com/goldencode/p2j/persist/serial/XmlExport.java'
--- src/com/goldencode/p2j/persist/serial/XmlExport.java	2022-10-14 12:38:17 +0000
+++ src/com/goldencode/p2j/persist/serial/XmlExport.java	2022-11-11 18:30:41 +0000
@@ -40,6 +40,9 @@
 **     IAS 20220926 Fixed WRITE-XMLSCHEMA support.
 **     IAS 20221013 Case-insensitive comparing of FORMAT value with a default one.
 **     IAS 20221014 Do not add prefix to the attribute name.
+**     IAS 20221110 Multiple fixes in the WRITE-XMLSCHEMA support. The most important one is the
+**                  external schema support for DATASETs
+**     IAS 20221111 Fixed WRITE-XML for DATASET.
 */
 
 /*
@@ -100,13 +103,17 @@
 import java.io.*;
 import java.lang.reflect.*;
 import java.math.*;
+import java.nio.file.*;
 import java.util.*;
+import java.util.stream.*;
+
 import javax.xml.stream.*;
 
 import org.apache.commons.lang3.*;
 import org.apache.commons.lang3.tuple.*;
 import com.ctc.wstx.api.*;
 import com.goldencode.p2j.persist.*;
+import com.goldencode.p2j.persist.orm.*;
 import com.goldencode.p2j.persist.serial.SerializeOptions.XmlNodeType;
 import com.goldencode.p2j.util.*;
 
@@ -143,6 +150,9 @@
    /** Character encoding (not currently used). */
    private final String encoding;
    
+   /** Flag indicating that we're creating external schema */
+   private boolean external = false;
+   
    /** XML stream writer */
    private XMLStreamWriter writer = null;
    
@@ -273,20 +283,36 @@
       }
       final String dsName = dsName1;
       character nsUri = dataSet.namespaceURI();
-      String nsUriStr = (nsUri.isUnknown()) ? "" : nsUri.toStringMessage();
+      character nsPrefix = dataSet.namespacePrefix();
+      String nsUriStr = (nsUri.isUnknown()) ? "" : nsUri.toJavaType();
+      String nsPrefixStr = nsPrefix.toJavaType();
       String nodeNameStr = dataSet.getXmlNodeNameInternal();
+      Map<String, TempTableSchema> tables = tables(dataSet, nsUriStr, false);
+      if (tables == null)
+      {
+         return false;
+      }
       this.ds = dataSet;
       
       return write(() -> {
-         writer.writeStartElement(nodeNameStr);
+         writer.writeStartElement((nsPrefixStr == null ? "" : nsPrefixStr + ":") + nodeNameStr);
          if (!nsUriStr.isEmpty())
          {
-            writer.writeAttribute("xmlns", nsUriStr);
+            writer.writeAttribute(
+                     "xmlns" + (nsPrefixStr == null ? "" : ":" + nsPrefixStr), 
+                     nsUriStr);
          }
          writer.writeAttribute(ATTR_NS_XSI, NS_URI);
-         if (schemaLocation != null && !schemaLocation.isEmpty())
+         if (schemaLocation != null)
          {
-            writer.writeAttribute("xsi:noNamespaceSchemaLocation", schemaLocation);
+            if (nsUriStr.isEmpty())
+            {
+               writer.writeAttribute("xsi:noNamespaceSchemaLocation", schemaLocation);
+            }
+            else
+            {
+               writer.writeAttribute("xsi:schemaLocation", nsUriStr + " " + schemaLocation);
+            }
          }
          lineBreak();
          ++indentLevel;
@@ -294,7 +320,8 @@
          if (writeXmlSchema)
          {
             if (!writeDatasetSchemaImpl(
-                     dataSet, minXmlSchema, !omitInitialValues, dsName, nsUriStr, nodeNameStr))
+                     dataSet, minXmlSchema, !omitInitialValues, dsName, nsUriStr, 
+                     nsPrefixStr, nodeNameStr, tables))
             {
                return false;
             }
@@ -341,11 +368,18 @@
             }
             
             TemporaryBuffer buffer = (TemporaryBuffer) after.buffer();
+
             TempTableSchema schema = new TempTableSchema(buffer, false);
-            if (!serializeTempTable(null, buffer, schema.getXmlName(), nsUriStr, 
-                                    omitInitialValues, false, writeBeforeImage, false))
-            {
-               return false;
+            ttNsPrefix = schema.namespacePrefix();
+            String ttNsUri = schema.namespaceURI();
+            if (ttNsUri.isEmpty())
+            {
+               ttNsPrefix = nsPrefixStr;
+            }
+            if (!serializeTempTable(null, buffer, schema.getXmlName(), ttNsUri, 
+                     omitInitialValues, false, writeBeforeImage, false))
+            {
+                return false;
             }
             
             if (!hasChanges && after.isAfterBuffer())
@@ -390,17 +424,23 @@
                }
                
                String bufName = after.name().toStringMessage();
-               if (!serializeTempTable(null, buffer, bufName, nsUriStr, 
-                                       omitInitialValues, false, writeBeforeImage, true))
+               TempTableSchema schema = new TempTableSchema(buffer, false);
+               ttNsPrefix = schema.namespacePrefix();
+               String ttNsUri = schema.namespaceURI();
+               if (ttNsUri.isEmpty())
+               {
+                  ttNsPrefix = nsPrefixStr;
+               }
+               if (!serializeTempTable(null, buffer, bufName, ttNsUri, 
+                        omitInitialValues, false, writeBeforeImage, true))
                {
                   return false;
                }
+               --indentLevel;
+               indent();
+               writer.writeEndElement(); // prods:before
+               lineBreak();
             }
-            
-            --indentLevel;
-            indent();
-            writer.writeEndElement(); // prods:before
-            lineBreak();
          }
          
          if (!prodsErrors.isEmpty())
@@ -531,7 +571,14 @@
          
          if (schemaLocation != null && !schemaLocation.isEmpty())
          {
-            writer.writeAttribute("xsi:noNamespaceSchemaLocation", schemaLocation);
+            if (nsUri.isEmpty())
+            {
+               writer.writeAttribute("xsi:noNamespaceSchemaLocation", schemaLocation);
+            }
+            else
+            {
+               writer.writeAttribute("xsi:schemaLocation", nsUri + " " + schemaLocation);
+            }
          }
          lineBreak();
          ++indentLevel;
@@ -589,13 +636,52 @@
       
       String dsName = dataSet.name().toStringMessage();
       character nsUri = dataSet.namespaceURI();
+      character nsPrefix = dataSet.namespacePrefix();
       String nsUriStr = (nsUri.isUnknown()) ? "" : nsUri.toStringMessage();
+      String nsPrefixStr = (nsPrefix.isUnknown()) ? null : nsPrefix.toStringMessage();
       String nodeNameStr = dataSet.getXmlNodeNameInternal();
       this.ds = dataSet;
+      Map<String, TempTableSchema> tables = tables(dataSet, nsUriStr, true);
+      if (tables == null)
+      {
+         return false;
+      }
 //      this.isSchemaOnly = true;
       
       return write(() -> writeDatasetSchemaImpl(
-            dataSet, minSchema, !noInitial, dsName, nsUriStr, nodeNameStr));
+            dataSet, minSchema, !noInitial, dsName, nsUriStr, nsPrefixStr, nodeNameStr, tables));
+   }
+   
+   /**
+    * Extract tables from the DATASET 
+    * @param dataSet
+    *        DATASET to be processed
+    * @param nsUriStr
+    *        DATASET XML namespace URI
+    * @return map of tables by legacy name
+    */
+   private Map<String, TempTableSchema> tables(DataSet dataSet, String nsUriStr, boolean forSchema)
+   {
+      Map<String, TempTableSchema> tables = dataSet.getBuffers().stream().
+               map(BufferImpl::buffer).
+               map(buffer -> new TempTableSchema(buffer, false)).
+               collect(Collectors.toMap(TempTableSchema::getTableName, tts -> tts));
+      boolean multipleURIs = tables.values().stream().
+               map(TempTableSchema::namespaceURI).
+               filter(uri -> uri != null).anyMatch(uri -> !nsUriStr.equals(uri));
+      if (!Serializator.TYPE_FILE.equals(target.getType().toUpperCase()) && 
+          multipleURIs && forSchema)
+      {
+         ErrorManager.recordOrShowError(new int[] { 13095 },
+                  new String[] { ErrorManager.replaceTokens(13095)},
+                  false,    // not modal
+                  false,    // no prefix
+                  false,    // not an error
+                  false,    // not as message
+                  true);    // add final dot
+         return null;
+      }
+      return tables;
    }
    
    /**
@@ -741,13 +827,54 @@
                                     boolean defaultValues)
    throws XMLStreamException
    {
+      return writeTableSchema(buffer, schema, minSchema, defaultValues, false);
+   }
+   /**
+    * Performs the export of a TEMP-TABLE schema.
+    *
+    * @param   buffer
+    *          A buffer of a {@code TempTable} to be described.
+    * @param   schema
+    *          The schema of the TEMP-TABLE.
+    * @param   minSchema
+    *          {@code true} to write minimal schema information; {@code false} to write verbose
+    *          schema information. Ignored if {@code writeXmlSchema} is {@code false}. Not
+    *          currently honored.
+    * @param   defaultValues
+    *          If {@code true}, record values which match default initial values will be omitted
+    *          from serialized output, else they will be included.
+    *          NOTE: actually setting [defaultValues] to [TRUE] which is the [omit-initial-values] from 
+    *                ABL will cause some extra info to be added in field description (see + attributes):
+    *                <pre>{@code
+    *                   <xsd:element name="f11" type="xsd:string" nillable="true"  +minOccurs="0" +default=""/>
+    *                   <xsd:element name="f12" type="xsd:int" nillable="true"     +minOccurs="0" +default="0"/>
+    *                   <xsd:element name="f13" type="xsd:date" nillable="true"    +minOccurs="0" +prodata:initial="prodata:unknown"/>
+    *                   <xsd:element name="f14" type="xsd:decimal" nillable="true" +minOccurs="0" +default="0.0"/>}
+    *                </pre>
+    * @param   inDataset
+    *          If {@code true}, this is part of a dataset SCHEMA and additional attributes will
+    *          be written.
+    *
+    * @return  {@code true} on success. Otherwise the error is already dispatched to 
+    *          {@code ErrorManager} before returning.
+    * 
+    * @throws  XMLStreamException
+    *          If XML-related issued occur.
+    */
+   private boolean writeTableSchema(BufferImpl buffer,
+                                    TempTableSchema schema,
+                                    boolean minSchema,
+                                    boolean defaultValues,
+                                    boolean inDataset)
+   throws XMLStreamException
+   {
       String tableName = schema.getTableName();
       String legacyName = schema.getName();
       AbstractTempTable tempTable = (AbstractTempTable) buffer.buffer().getParentTable();
       String xmlNodeName = tempTable.getXmlNodeName().toJavaType();
       String nsPrefix = tempTable.namespacePrefix().toJavaType();
       String nsUri = tempTable.namespaceURI().toJavaType();
-      boolean isDataSet = buffer.isBeforeBuffer() || buffer.isAfterBuffer();
+      boolean isDataSet = inDataset || buffer.isBeforeBuffer() || buffer.isAfterBuffer();
       
       indent();
       writer.writeStartElement("xsd:schema");
@@ -766,7 +893,10 @@
          indent();
          writer.writeStartElement("xsd:element");
          writer.writeAttribute("name", xmlNodeName == null ? tableName : xmlNodeName);
-         writer.writeAttribute("prodata:proTempTable", "true"); // String.valueOf(isDataSet)); TODO: when is this attribute 'false' ? 
+         if (!external)
+         {
+            writer.writeAttribute("prodata:proTempTable", "true"); // String.valueOf(isDataSet)); TODO: when is this attribute 'false' ? 
+         }
          if (isDataSet && !legacyName.equals(tableName))
          {
             writer.writeAttribute("prodata:tableName", legacyName);
@@ -800,8 +930,10 @@
                lineBreak();
                ++indentLevel;
                {
-                  String rowName = (xmlNodeName == null ? tableName : xmlNodeName) + "Row";
-                  if (!writeTableSchemaImpl(buffer, schema, rowName, defaultValues, minSchema, false))
+                  String rowName = (xmlNodeName == null ? tableName : xmlNodeName) + 
+                           (inDataset ? "" : "Row");
+                  if (!writeTableSchemaImpl(buffer, schema, rowName, 
+                           defaultValues, minSchema, inDataset))
                   {
                      return false;
                   }
@@ -817,7 +949,7 @@
             lineBreak();
             
             // in case of standalone TEMP-TABLE schema serialization unique indexes go here:
-            if (!minSchema && this.ds == null && !indexes.isEmpty())
+            if (!external && /*!minSchema &&*/ this.ds == null && !indexes.isEmpty())
             {
                for (Map.Entry<Integer, Pair<String, TableMapper.LegacyIndexInfo>> indexEntry : 
                     indexes.entrySet())
@@ -879,7 +1011,8 @@
          writer.writeEndElement(); // xsd:element
          lineBreak();
          
-         boolean hasIndexes = !minSchema && this.ds == null /*&& !this.isSchemaOnly*/ && !indexes.isEmpty();
+         boolean hasIndexes = !external && !minSchema && this.ds == null 
+                              /*&& !this.isSchemaOnly*/ && !indexes.isEmpty();
          int idxCounter = 0;
          if (hasIndexes)
          {
@@ -967,10 +1100,13 @@
             lineBreak();
          }
       }
-      --indentLevel;
-      indent();
-      writer.writeEndElement(); // xsd:schema
-      lineBreak();
+      if (!external)
+      {
+         --indentLevel;
+         indent();
+         writer.writeEndElement(); // xsd:schema
+         lineBreak();
+      }
       
       return true;
    }
@@ -1004,7 +1140,9 @@
                                           boolean defaultValues,
                                           String dsName,
                                           String nsUri,
-                                          String nodeName)
+                                          String nsPrefix,
+                                          String nodeName,
+                                          Map<String, TempTableSchema> tables)
    throws XMLStreamException
    {
       indent();
@@ -1013,18 +1151,60 @@
       writer.writeAttribute("xmlns", nsUri);
       if (!nsUri.isEmpty())
       {
-         writer.writeAttribute("xmlns:tns", nsUri);
+         writer.writeAttribute("xmlns:" + (nsPrefix != null ? nsPrefix : "tns"), nsUri);
          writer.writeAttribute("targetNamespace", nsUri);
          writer.writeAttribute("elementFormDefault", "qualified");
       }
       writer.writeAttribute("xmlns:prodata", "urn:schemas-progress-com:xml-prodata:0001");
+      for (TempTableSchema tts: tables.values())
+      {
+         String ns = tts.namespaceURI();
+         String prefix = tts.namespacePrefix();
+         if (ns != null && !"".equals(ns) && !nsUri.equals(ns) &&  
+             prefix != null && !"".equals(prefix))
+         {
+            writer.writeAttribute("xmlns:" + prefix, ns);
+         }
+      }
       lineBreak();
       ++indentLevel;
       {
          indent();
+         Map<String, String> external = new HashMap<>();
+         boolean hasImport = false;
+         for (TempTableSchema tts: tables.values())
+         {
+            String ns = tts.namespaceURI();
+            if (ns != null && !"".equals(ns) && !nsUri.equals(ns))
+            {
+               String fn = writeExternalSchema(tts, minSchema, defaultValues);
+               if (fn == null)
+               {
+                  return false;
+               }
+               external.put(tts.getName(), fn);
+               indent();
+               hasImport = true;
+               writer.writeStartElement("xsd:import");
+               writer.writeAttribute("namespace", ns);
+               writer.writeAttribute("schemaLocation", fn);
+               writer.writeEndElement();
+               lineBreak();
+            }
+         }
+         if (hasImport)
+         {
+            ++indentLevel;
+            indent();
+         }
+         ++indentLevel;
          writer.writeStartElement("xsd:element");
          writer.writeAttribute("name", nodeName);
          writer.writeAttribute("prodata:proDataSet", "true");
+         if (nsPrefix != null)
+         {
+            writer.writeAttribute("prodata:prefix", nsPrefix);
+         }
          if (!nodeName.equals(dsName))
          {
             writer.writeAttribute("prodata:datasetName", dsName);
@@ -1060,7 +1240,19 @@
                      
                      TemporaryBuffer buffer = (TemporaryBuffer) after.buffer();
                      TempTableSchema schema = new TempTableSchema(buffer, false);
-                     
+                     if (external.containsKey(schema.getName()))
+                     {
+                        // already serialized to external schema
+                        indent();
+                        writer.writeStartElement("xsd:element");
+                        writer.writeAttribute("ref", 
+                                 schema.namespacePrefix() + ":" + schema.getName());
+                        writer.writeAttribute("minOccurs", "0");
+                        writer.writeAttribute("maxOccurs", "unbounded");
+                        writer.writeEndElement();
+                        lineBreak();
+                        continue nextBuffer;
+                     }
                      if (!writeTableSchemaImpl(
                             after, schema, schema.getTableName(), defaultValues, minSchema, true))
                      {
@@ -1120,9 +1312,17 @@
             lineBreak();
             ++indentLevel;
             {
+               TempTableSchema tts = tables.get(idxPair.getLeft());
+               String prefix = tts.namespacePrefix();
+               if (prefix == null || "".equals(prefix))
+               {
+                  prefix = nsPrefix;
+               }
+               prefix = (prefix != null && !"".equals(prefix)) ? (prefix + ":") : "";
+               
                indent();
                writer.writeEmptyElement("xsd:selector");
-               writer.writeAttribute("xpath", ".//" + idxPair.getLeft());
+               writer.writeAttribute("xpath", ".//" + prefix + idxPair.getLeft());
                lineBreak();
                
                String[] comps = index.getComponents();
@@ -1131,7 +1331,7 @@
                {
                   indent();
                   writer.writeEmptyElement("xsd:field");
-                  writer.writeAttribute("xpath", comps[i]);
+                  writer.writeAttribute("xpath", prefix + comps[i]);
                   if (!dirs[i])
                   {
                      writer.writeAttribute("prodata:descending", "true");
@@ -1206,9 +1406,18 @@
             if (isKeyref)
             {
                indent();
+               String prefix1 = nsPrefix == null || "".equals(nsPrefix) ? "" : nsPrefix + ":";
+               String prefix2 = tables.get(rel.getChildBuffer().unwrapBuffer().name().toJavaType()).
+                                       namespacePrefix();
+               if (prefix2 == null || "".equals(prefix2))
+               {
+                  prefix2 = nsPrefix;
+               }
+               prefix2 = (prefix2 != null && !"".equals(prefix2)) ? (prefix2 + ":") : "";
+
                writer.writeStartElement("xsd:keyref");
                writer.writeAttribute("name", rel.name().toJavaType());
-               writer.writeAttribute("refer", idxName);
+               writer.writeAttribute("refer", prefix1 + idxName);
                if (rel.isNested().toJavaType())
                {
                   writer.writeAttribute("prodata:nested", "true");
@@ -1218,7 +1427,9 @@
                {
                   indent();
                   writer.writeStartElement("xsd:selector");
-                  writer.writeAttribute("xpath", ".//" + rel.getChildBuffer().unwrapBuffer().name().toJavaType());
+                  writer.writeAttribute("xpath", 
+                           ".//" + prefix2 + rel.getChildBuffer().unwrapBuffer().
+                           name().toJavaType());
                   writer.writeEndElement();
                   lineBreak();
                   
@@ -1226,7 +1437,7 @@
                   {
                      indent();
                      writer.writeStartElement("xsd:field");
-                     writer.writeAttribute("xpath", field);
+                     writer.writeAttribute("xpath", prefix2 + field);
                      writer.writeEndElement();
                      lineBreak();
                   }
@@ -1249,106 +1460,109 @@
          writer.writeEndElement(); // xsd:element
          lineBreak();
          
-         if (prodataRelationCount > 0 || (/* !this.isSchemaOnly  && */ !indexes.isEmpty()))
+         if (!minSchema)
          {
-            indent();
-            writer.writeStartElement("xsd:annotation");
-            lineBreak();
-            ++indentLevel;
+            if (prodataRelationCount > 0 || (/* !this.isSchemaOnly  && */ !indexes.isEmpty()))
             {
                indent();
-               writer.writeStartElement("xsd:appinfo");
+               writer.writeStartElement("xsd:annotation");
                lineBreak();
                ++indentLevel;
                {
-//                  if (!isSchemaOnly)
-//                  {
-                     for (Map.Entry<Integer, Pair<String, TableMapper.LegacyIndexInfo>> indexEntry :
-                           indexes.entrySet())
-                     {
-                        Pair<String, TableMapper.LegacyIndexInfo> idxPair = indexEntry.getValue();
-                        TableMapper.LegacyIndexInfo index = idxPair.getRight();
-                        if (index.isUnique())
-                        {
-                           continue; // only NON-unique indexes here
-                        }
-                        
-                        indent();
-                        writer.writeStartElement("prodata:index");
-                        writer.writeAttribute("name", index.getLegacyName());
-                        if (index.isEffectivePrimary())
-                        {
-                           writer.writeAttribute("prodata:primaryIndex", "true");
-                        }
-                        if (index.isWord())
-                        {
-                           writer.writeAttribute("prodata:wordIndex", "true");
-                        }
-                        lineBreak();
-                        ++indentLevel;
-                        {
-                           indent();
-                           writer.writeEmptyElement("prodata:table");
-                           writer.writeAttribute("name", idxPair.getLeft());
-                           lineBreak();
+                  indent();
+                  writer.writeStartElement("xsd:appinfo");
+                  lineBreak();
+                  ++indentLevel;
+                  {
+//                     if (!isSchemaOnly)
+//                     {
+                        for (Map.Entry<Integer, Pair<String, TableMapper.LegacyIndexInfo>> indexEntry :
+                              indexes.entrySet())
+                        {
+                           Pair<String, TableMapper.LegacyIndexInfo> idxPair = indexEntry.getValue();
+                           TableMapper.LegacyIndexInfo index = idxPair.getRight();
+                           if (index.isUnique())
+                           {
+                              continue; // only NON-unique indexes here
+                           }
                            
-                           String[] comps = index.getComponents();
-                           boolean[] dirs = index.getComponentsDirection();
-                           for (int i = 0; i < comps.length; i++)
+                           indent();
+                           writer.writeStartElement("prodata:index");
+                           writer.writeAttribute("name", index.getLegacyName());
+                           if (index.isEffectivePrimary())
+                           {
+                              writer.writeAttribute("prodata:primaryIndex", "true");
+                           }
+                           if (index.isWord())
+                           {
+                              writer.writeAttribute("prodata:wordIndex", "true");
+                           }
+                           lineBreak();
+                           ++indentLevel;
                            {
                               indent();
-                              writer.writeEmptyElement("prodata:field");
-                              writer.writeAttribute("name", comps[i]);
-                              if (!dirs[i])
+                              writer.writeEmptyElement("prodata:table");
+                              writer.writeAttribute("name", idxPair.getLeft());
+                              lineBreak();
+                              
+                              String[] comps = index.getComponents();
+                              boolean[] dirs = index.getComponentsDirection();
+                              for (int i = 0; i < comps.length; i++)
                               {
-                                 writer.writeAttribute("prodata:descending", "true");
+                                 indent();
+                                 writer.writeEmptyElement("prodata:field");
+                                 writer.writeAttribute("name", comps[i]);
+                                 if (!dirs[i])
+                                 {
+                                    writer.writeAttribute("prodata:descending", "true");
+                                 }
+                                 lineBreak();
                               }
-                              lineBreak();
                            }
-                        }
-                        --indentLevel;
+                           --indentLevel;
+                           indent();
+                           writer.writeEndElement(); // prodata:index
+                           lineBreak();
+                        }
+                     }
+                     
+                     for (int k = 0; k < relCount; k++)
+                     {
+                        DataRelation rel = (DataRelation) dataSet.getRelation(k + 1).getResource();// base-1
+                        if (keyrefs.contains(rel))
+                        {
+                           continue; // this relation was serialized as a [xsd:keyref] above
+                        }
+                        if (rel.isParentIdRelation().getValue())
+                        {
+                           continue;
+                        }
+                        
                         indent();
-                        writer.writeEndElement(); // prodata:index
+                        writer.writeEmptyElement("prodata:relation");
+                        writer.writeAttribute("name", rel.name().toStringMessage());
+                        if (rel.isNested().booleanValue())
+                        {
+                           writer.writeAttribute("prodata:nested", "true");
+                        }
+                        writer.writeAttribute("prodata:parent", rel.getParentBuffer().unwrap().name().toStringMessage());
+                        writer.writeAttribute("prodata:child", rel.getChildBuffer().unwrap().name().toStringMessage());
+                        writer.writeAttribute("prodata:relationFields", rel.getRelationFields().toStringMessage());
                         lineBreak();
                      }
                   }
-                  
-                  for (int k = 0; k < relCount; k++)
-                  {
-                     DataRelation rel = (DataRelation) dataSet.getRelation(k + 1).getResource();// base-1
-                     if (keyrefs.contains(rel))
-                     {
-                        continue; // this relation was serialized as a [xsd:keyref] above
-                     }
-                     if (rel.isParentIdRelation().getValue())
-                     {
-                        continue;
-                     }
-                     
-                     indent();
-                     writer.writeEmptyElement("prodata:relation");
-                     writer.writeAttribute("name", rel.name().toStringMessage());
-                     if (rel.isNested().booleanValue())
-                     {
-                        writer.writeAttribute("prodata:nested", "true");
-                     }
-                     writer.writeAttribute("prodata:parent", rel.getParentBuffer().unwrap().name().toStringMessage());
-                     writer.writeAttribute("prodata:child", rel.getChildBuffer().unwrap().name().toStringMessage());
-                     writer.writeAttribute("prodata:relationFields", rel.getRelationFields().toStringMessage());
-                     lineBreak();
-                  }
+                  --indentLevel;
+                  indent();
+                  writer.writeEndElement(); // xsd:appinfo
+                  lineBreak();
                }
                --indentLevel;
                indent();
-               writer.writeEndElement(); // xsd:appinfo
+               writer.writeEndElement(); // xsd:annotation
                lineBreak();
             }
-            --indentLevel;
-            indent();
-            writer.writeEndElement(); // xsd:annotation
-            lineBreak();
+//         }
          }
-//      }
       --indentLevel;
       indent();
       writer.writeEndElement(); // xsd:schema
@@ -1358,6 +1572,47 @@
    }
    
    /**
+    * Write external schema for a table
+    * @param tts
+    *        table in question
+    * @param   minSchema
+    *          {@code true} to write minimal schema information; {@code false} to write verbose
+    *          schema information. Ignored if {@code writeXmlSchema} is {@code false}. Not
+    *          currently honored.
+    * @param   defaultValues
+    *          If {@code true}, the initial values for the fields will be written. 
+    * @return name of the schema file
+    * 
+    * @throws  XMLStreamException
+    *          If XML-related issued occur.
+    */
+   private String writeExternalSchema(TempTableSchema tts, 
+            boolean minSchema, boolean defaultValues) 
+   throws XMLStreamException
+   {
+      Path path = Paths.get(((character) target.getDestination()).toJavaType());
+      Path fileName = path.getFileName();
+      String fn = fileName.toString();
+      String extSchema = fn.substring(0, fn.length() - ".xsd".length()) + "_" + tts.getName() + ".xsd";
+      String extPath = path.getParent().toString() + "/" + extSchema;
+      XmlExport export = new XmlExport(new TargetData("file", extPath), format, encoding);
+      export.external = true;
+      TemporaryBuffer tb = (TemporaryBuffer)tts.buffer();
+      boolean ok = export.write(
+               () -> export.writeTableSchema((BufferImpl)tb.getDMOProxy(), tts, 
+                        minSchema, defaultValues, true)
+      );
+      if (!ok)
+      {
+         return null;
+      }
+      this.indexes.putAll(export.indexes);
+      this.uidxByUniqueNames.putAll(export.uidxByUniqueNames);
+      this.uidxUniqueNames.putAll(export.uidxUniqueNames);
+      return extSchema;
+   }
+
+   /**
     * Writes the XML-SCHEMA of a TEMP-TABLE to XML stream.
     *
     * @param   buffer
